Subject: [quicwg/base-drafts] acf67a: Use PTO to declare in-flight packets lost (#1965)

From: ianswett <[email-masked]>
Date: Wed, 26 Dec 2018 20:21:52 -0800

Branch: refs/heads/master
  Home:   https://github.com/quicwg/base-drafts
  Commit: acf67af530692cf5be7ad2e28a47eebb4daa1972
      https://github.com/quicwg/base-drafts/commit/acf67af530692cf5be7ad2e28a47eebb4daa1972
  Author: ianswett <[email-masked]>
  Date:   2018-12-26 (Wed, 26 Dec 2018)

  Changed paths:
    M draft-ietf-quic-recovery.md

  Log Message:
  -----------
  Use PTO to declare in-flight packets lost (#1965)

* Prevent an unlikely deadlock

QUIC, unlike TCP, allows the connection to get into a situation where there could be packets in flight, and a connection could even be CWND limited, but there may not be any outstanding data to retransmit.

The suggested solution is to send a retransmittable frame.

* Update draft-ietf-quic-recovery.md

* Update draft-ietf-quic-recovery.md

* Mike in-flight

* Update draft-ietf-quic-recovery.md

* Not a deadlock

* Update draft-ietf-quic-recovery.md

Co-Authored-By: ianswett <[email-masked]>

* Jana's suggestions

* Update draft-ietf-quic-recovery.md

* Proposed change: MUST mark inflight data as lost

A proposal: I think I prefer to mark things as lost instead of suggesting that a sender SHOULD send something when there's really nothing to be sent.  I was starting to rephrase your PR to say "SHOULD send ack-eliciting packet, but MAY mark as lost", and I needed to explain how a sender makes this choice. I realized that if it's been long enough (PTO is long enough) and there's nothing left to send, then maybe it is sensible to mark anything pending as lost. So, I changed my suggestion to that, which is this PR (against your PR).

* reflow

* add MAY re-arm PTO

* more rephrasing

* more simple

* comma

      **NOTE:** This service has been marked for deprecation: https://developer.github.com/changes/2018-04-25-github-services-deprecation/

      Functionality will be removed from GitHub.com on January 31st, 2019.